// ----------------------------------------------------------------------------
// J.Kleimola and P.McGlynn, "Streamlining the Flow of Open Sound Control"
// (submitted to SMC-2011)
// ----------------------------------------------------------------------------

class OscStreamliner
{
  HashMap str2int;  
  HashMap int2str;  
  
  OscStreamliner()
  {
    createMaps();
  }
  
  OscStreamliner(String path)
  {
    createMaps();
    setmap(path);
  }

  void createMaps()
  {
    str2int = new HashMap();
    int2str = new HashMap();
  }

  // -- read the mapping file into the dictionary 
  void setmap(String path)
  {
    String[] lines = loadStrings(path);
    for (int i=0; i<lines.length; i++)
    {
      String[] pair = splitTokens(lines[i], ",");
      str2int.put(pair[1], Integer.parseInt(pair[0]));
      int2str.put(Integer.parseInt(pair[0]), pair[1]);
    }
  }
  
  // -- address conversion: string -> integer
  int iaddress(String address)
  {
    return (Integer)str2int.get(address);
  }
  
   // -- address conversion: integer -> string
  String address(int iaddr)
  {
    return int2str.get(iaddr).toString();
  }
}  
